Imports System
Imports System.ComponentModel
Imports System.Collections.Generic
Imports System.Windows.Forms
Imports System.Drawing
Imports System.Text

''' <![CDATA[
''' <kbyteWorldMacros>
'''   <name>  </name>
'''   <version>1.0</version>
'''   <author>Aleksey S Nemiro</author>
'''   <mail>admin@kbyte.ru</mail>
'''   <urls>http://aleksey.nemiro.ru,http://kbyte.ru</urls>
'''   <copyright>Copyright  Nemiro AS, 2008</copyright>
'''   <description>
'''    ,           
'''   </description>
'''   <legal>
'''   - ,      .
'''   -         . 
'''   -     .
'''   </legal>
''' </kbyteWorldMacros>
''' ]]>
Public Class KbyteWorldMacros
#Region "   Kbyte World Macros Creator v.1.0"
#Region ">> !   ! <<"
  '
  '     
  '      KbyteWorld.exe,
  '  KbyteWorld.exe     
  '   .
  '
  Private _Macros As Kbyte.World.Macros

  Public Sub New(ByVal m As Kbyte.World.Macros)
    _Macros = m
  End Sub

  '
  '        KbyteWorld.exe
  '   _Macros
  '
#End Region

  Public LenaForm As Form '    ()
  Public MacrosForm As Form '  
  Public MacrosFormClosing As Boolean = False '     

  ''' <summary>
  '''  
  ''' </summary>
  ''' <param name="f">    Kbyte World</param>
  Public Sub Run(ByVal f As Form)
    LenaForm = f
    Dim MacrosForm As New OpenenForms(Me)
    MacrosForm.MdiParent = f
    MacrosForm.Show()
    '>> !    ! <<
    '
    '      KbyteWorld.exe
    '  ,     .
    '
    If _Macros IsNot Nothing Then _Macros.IsRun = True
  End Sub

  ''' <summary>
  '''   
  ''' </summary>
  Public Sub [Stop]()
    If MacrosForm IsNot Nothing AndAlso Not MacrosFormClosing Then
      MacrosForm.Close()
      MacrosForm = Nothing
    End If

    ' >> !    ! <<
    '
    '      KbyteWorld.exe
    '  ,     .
    '
    If _Macros IsNot Nothing Then _Macros.IsRun = False
  End Sub
#End Region

  Public Class OpenenForms

    Private _kwm As KbyteWorldMacros

    Private Sub UpdateFormList()
      ListView1.Items.Clear()
      TreeView1.Nodes.Clear()
      ImageList1.Images.Clear()
      For Each f As Form In Application.OpenForms
        Dim itm As New ListViewItem(f.Text)
        If f.Icon IsNot Nothing Then
          ImageList1.Images.Add(f.Icon)
          itm.ImageIndex = ImageList1.Images.Count - 1
        End If
        itm.Tag = f
        ListView1.Items.Add(itm)
      Next
    End Sub

    Private Sub ListView1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ListView1.SelectedIndexChanged
      TreeView1.Nodes.Clear()
      If ListView1.FocusedItem Is Nothing OrElse ListView1.FocusedItem.Tag Is Nothing Then Return
      For Each c As Control In CType(ListView1.FocusedItem.Tag, Form).Controls
        Dim node As New TreeNode(c.Name & " (" & c.GetType().ToString() & ")")
        AddControlsToNode(node, c.Controls)
        TreeView1.Nodes.Add(node)
      Next
    End Sub

    Private Sub AddControlsToNode(ByRef node As TreeNode, ByVal ctrls As Object)
      If ctrls Is Nothing OrElse ctrls.Count <= 0 Then Return
      For Each c As Control In ctrls
        Dim newNode As New TreeNode(c.Name & " (" & c.GetType().ToString() & ")")
        If c.Controls IsNot Nothing AndAlso c.Controls.Count > 0 Then AddControlsToNode(newNode, c.Controls)
        node.Nodes.Add(newNode)
      Next
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
      UpdateFormList()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
      Close()
    End Sub

    Public Sub New(ByVal kwm As KbyteWorldMacros)
      ' This call is required by the Windows Form Designer.
      InitializeComponent()
      ' Add any initialization after the InitializeComponent() call.
      _kwm = kwm
    End Sub

    Private Sub OpenenForms_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
      UpdateFormList()
    End Sub

    Private Sub OpenenForms_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
      If _kwm IsNot Nothing Then
        _kwm.MacrosFormClosing = True
        _kwm.Stop()
      End If
    End Sub

  End Class

  <Global.Microsoft.VisualBasic.CompilerServices.DesignerGenerated()> _
  Partial Class OpenenForms
    Inherits System.Windows.Forms.Form

    'Form overrides dispose to clean up the component list.
    <System.Diagnostics.DebuggerNonUserCode()> _
    Protected Overrides Sub Dispose(ByVal disposing As Boolean)
      Try
        If disposing AndAlso components IsNot Nothing Then
          components.Dispose()
        End If
      Finally
        MyBase.Dispose(disposing)
      End Try
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> _
    Private Sub InitializeComponent()
      Me.components = New System.ComponentModel.Container
      Me.TableLayoutPanel1 = New System.Windows.Forms.TableLayoutPanel
      Me.TableLayoutPanel2 = New System.Windows.Forms.TableLayoutPanel
      Me.ImageList1 = New System.Windows.Forms.ImageList(Me.components)
      Me.ListView1 = New System.Windows.Forms.ListView
      Me.ColumnHeader1 = New System.Windows.Forms.ColumnHeader
      Me.TableLayoutPanel3 = New System.Windows.Forms.TableLayoutPanel
      Me.Button1 = New System.Windows.Forms.Button
      Me.Button2 = New System.Windows.Forms.Button
      Me.TreeView1 = New System.Windows.Forms.TreeView
      Me.TableLayoutPanel1.SuspendLayout()
      Me.TableLayoutPanel2.SuspendLayout()
      Me.TableLayoutPanel3.SuspendLayout()
      Me.SuspendLayout()
      '
      'TableLayoutPanel1
      '
      Me.TableLayoutPanel1.ColumnCount = 1
      Me.TableLayoutPanel1.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100.0!))
      Me.TableLayoutPanel1.Controls.Add(Me.TableLayoutPanel2, 0, 0)
      Me.TableLayoutPanel1.Controls.Add(Me.TableLayoutPanel3, 0, 1)
      Me.TableLayoutPanel1.Dock = System.Windows.Forms.DockStyle.Fill
      Me.TableLayoutPanel1.Location = New System.Drawing.Point(0, 0)
      Me.TableLayoutPanel1.Name = "TableLayoutPanel1"
      Me.TableLayoutPanel1.RowCount = 2
      Me.TableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100.0!))
      Me.TableLayoutPanel1.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Absolute, 38.0!))
      Me.TableLayoutPanel1.Size = New System.Drawing.Size(630, 199)
      Me.TableLayoutPanel1.TabIndex = 0
      '
      'TableLayoutPanel2
      '
      Me.TableLayoutPanel2.ColumnCount = 2
      Me.TableLayoutPanel2.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50.0!))
      Me.TableLayoutPanel2.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 50.0!))
      Me.TableLayoutPanel2.Controls.Add(Me.ListView1, 0, 0)
      Me.TableLayoutPanel2.Controls.Add(Me.TreeView1, 1, 0)
      Me.TableLayoutPanel2.Dock = System.Windows.Forms.DockStyle.Fill
      Me.TableLayoutPanel2.Location = New System.Drawing.Point(3, 3)
      Me.TableLayoutPanel2.Name = "TableLayoutPanel2"
      Me.TableLayoutPanel2.RowCount = 1
      Me.TableLayoutPanel2.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 50.0!))
      Me.TableLayoutPanel2.Size = New System.Drawing.Size(624, 155)
      Me.TableLayoutPanel2.TabIndex = 0
      '
      'ImageList1
      '
      Me.ImageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit
      Me.ImageList1.ImageSize = New System.Drawing.Size(16, 16)
      Me.ImageList1.TransparentColor = System.Drawing.Color.Transparent
      '
      'ListView1
      '
      Me.ListView1.Columns.AddRange(New System.Windows.Forms.ColumnHeader() {Me.ColumnHeader1})
      Me.ListView1.Dock = System.Windows.Forms.DockStyle.Fill
      Me.ListView1.Location = New System.Drawing.Point(3, 3)
      Me.ListView1.Name = "ListView1"
      Me.ListView1.Size = New System.Drawing.Size(306, 149)
      Me.ListView1.SmallImageList = Me.ImageList1
      Me.ListView1.TabIndex = 1
      Me.ListView1.UseCompatibleStateImageBehavior = False
      Me.ListView1.View = System.Windows.Forms.View.Details
      '
      'ColumnHeader1
      '
      Me.ColumnHeader1.Text = ""
      Me.ColumnHeader1.Width = 200
      '
      'TableLayoutPanel3
      '
      Me.TableLayoutPanel3.ColumnCount = 3
      Me.TableLayoutPanel3.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 90.0!))
      Me.TableLayoutPanel3.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Percent, 100.0!))
      Me.TableLayoutPanel3.ColumnStyles.Add(New System.Windows.Forms.ColumnStyle(System.Windows.Forms.SizeType.Absolute, 90.0!))
      Me.TableLayoutPanel3.Controls.Add(Me.Button1, 2, 0)
      Me.TableLayoutPanel3.Controls.Add(Me.Button2, 0, 0)
      Me.TableLayoutPanel3.Dock = System.Windows.Forms.DockStyle.Fill
      Me.TableLayoutPanel3.Location = New System.Drawing.Point(3, 164)
      Me.TableLayoutPanel3.Name = "TableLayoutPanel3"
      Me.TableLayoutPanel3.RowCount = 1
      Me.TableLayoutPanel3.RowStyles.Add(New System.Windows.Forms.RowStyle(System.Windows.Forms.SizeType.Percent, 100.0!))
      Me.TableLayoutPanel3.Size = New System.Drawing.Size(624, 32)
      Me.TableLayoutPanel3.TabIndex = 1
      '
      'Button1
      '
      Me.Button1.DialogResult = System.Windows.Forms.DialogResult.Cancel
      Me.Button1.Dock = System.Windows.Forms.DockStyle.Fill
      Me.Button1.Location = New System.Drawing.Point(537, 3)
      Me.Button1.Name = "Button1"
      Me.Button1.Size = New System.Drawing.Size(84, 26)
      Me.Button1.TabIndex = 0
      Me.Button1.Text = ""
      Me.Button1.UseVisualStyleBackColor = True
      '
      'Button2
      '
      Me.Button2.Dock = System.Windows.Forms.DockStyle.Fill
      Me.Button2.Location = New System.Drawing.Point(3, 3)
      Me.Button2.Name = "Button2"
      Me.Button2.Size = New System.Drawing.Size(84, 26)
      Me.Button2.TabIndex = 1
      Me.Button2.Text = ""
      Me.Button2.UseVisualStyleBackColor = True
      '
      'TreeView1
      '
      Me.TreeView1.Dock = System.Windows.Forms.DockStyle.Fill
      Me.TreeView1.Location = New System.Drawing.Point(315, 3)
      Me.TreeView1.Name = "TreeView1"
      Me.TreeView1.Size = New System.Drawing.Size(306, 149)
      Me.TreeView1.TabIndex = 2
      '
      'OpenenForms
      '
      Me.AutoScaleDimensions = New System.Drawing.SizeF(6.0!, 13.0!)
      Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font
      Me.CancelButton = Me.Button1
      Me.ClientSize = New System.Drawing.Size(630, 199)
      Me.Controls.Add(Me.TableLayoutPanel1)
      Me.MinimumSize = New System.Drawing.Size(300, 180)
      Me.Name = "OpenenForms"
      Me.Text = "OpenenForms"
      Me.TableLayoutPanel1.ResumeLayout(False)
      Me.TableLayoutPanel2.ResumeLayout(False)
      Me.TableLayoutPanel3.ResumeLayout(False)
      Me.ResumeLayout(False)

    End Sub
    Friend WithEvents TableLayoutPanel1 As System.Windows.Forms.TableLayoutPanel
    Friend WithEvents TableLayoutPanel2 As System.Windows.Forms.TableLayoutPanel
    Friend WithEvents ImageList1 As System.Windows.Forms.ImageList
    Friend WithEvents ListView1 As System.Windows.Forms.ListView
    Friend WithEvents TableLayoutPanel3 As System.Windows.Forms.TableLayoutPanel
    Friend WithEvents Button1 As System.Windows.Forms.Button
    Friend WithEvents Button2 As System.Windows.Forms.Button
    Friend WithEvents ColumnHeader1 As System.Windows.Forms.ColumnHeader
    Friend WithEvents TreeView1 As System.Windows.Forms.TreeView
  End Class

End Class