using System;
using System.Windows.Forms;
using System.ComponentModel;

/// <![CDATA[
/// <kbyteWorldMacros>
///   <name>  </name>
///   <version>1.0</version>
///   <author>Aleksey S Nemiro</author>
///   <mail>admin@kbyte.ru</mail>
///   <urls>http://kbyte.ru,http://aleksey.nemiro.ru</urls>
///   <copyright>Copyright  Nemiro AS, 2008</copyright>
///   <description>
///            (Kbyte World).
///              .
///   </description>
///   <legal>
///           GNU General Public License! :) 
///   </legal>
/// </kbyteWorldMacros>
/// ]]>
public class KbyteWorldMacros 
{
  #region >>    ! <<
  /*
   *     
   *      KbyteWorld.exe,
   *  KbyteWorld.exe     
   *   .
   */
  private Kbyte.World.Macros _Macros;

  public KbyteWorldMacros(Kbyte.World.Macros m)
  {
    _Macros = m;
  }
  #endregion
  
  private Form MainForm;
  private Timer myTimer;
  private string MainTitle = "";
  
  /// <summary>
  ///    
  /// </summary>
  /// <param name="f"> </param>
  public void Run(Form f) 
  {
    MainForm = f;
    MainTitle = f.Text;
    myTimer = new Timer();
    myTimer.Tick += new EventHandler(myTimer_Tick);
    myTimer.Interval = 800;
    myTimer.Enabled = true;

    #region >>    ! <<
    /*
     *      KbyteWorld.exe
     *  ,     .
     */
    if (_Macros != null)
      _Macros.IsRun = true;
    #endregion
  }

  /// <summary>
  /// ,    
  /// </summary>
  public void Stop()
  {
    myTimer.Enabled = false;
    MainForm.Text = MainTitle;
    myTimer = null;

    #region >>    ! <<
    /*
     *      KbyteWorld.exe
     *  ,     .
     */
    if (_Macros != null)
      _Macros.IsRun = false;
    #endregion
  }

  private void myTimer_Tick(object sender, EventArgs e)
  {
    MainForm.Text = String.Format("{0} ::: {1}", MainTitle, DateTime.Now.ToString("HH:mm:ss"));
  }
}